Foxit PDF SDK

Public Types | Public Member Functions | List of all members
foxit.pdf.actions.ActionCallback Class Reference

Inherits SystemIDisposable.

## Public Types
enum | AppInfoType { AppInfoType.e_AppInfoTypeFormsVersion = 0x0, AppInfoType.e_AppInfoTypeViewerType = 0x01, AppInfoType.e_AppInfoTypeViewerVariation = 0x02, AppInfoType.e_AppInfoTypeViewerVersion = 0x03, AppInfoType.e_AppInfoTypeAppVersion = 0x04 }
| Enumeration for application's information type. More...
enum | JSFieldValueChangeType { JSFieldValueChangeType.e_JSFieldValueChangedByFormat = 0, JSFieldValueChangeType.e_JSFieldValueChangedByCalculation = 1, JSFieldValueChangeType.e_JSFieldValueChangedBySetValue = 2, JSFieldValueChangeType.e_JSFieldValueChangedBySetReadOnly = 3, JSFieldValueChangeType.e_JSFieldValueChangedByFillColor = 4 }
| Enumeration for javascript field value change type. More...
enum | JsMailResult { JsMailResult.e_JSMailResultFailed = 0, JsMailResult.e_JSMailResultSuccess = 1, JsMailResult.e_JSMailResultUserAbort = 2 }
| Enumeration for result of the mail. More...
enum | JSMediaPlayerState { JSMediaPlayerState.e_JSMediaPlayerStateOpen = 0, JSMediaPlayerState.e_JSMediaPlayerStateClose = 1, JSMediaPlayerState.e_JSMediaPlayerStatePlaying = 2, JSMediaPlayerState.e_JSMediaPlayerStateStop = 3, JSMediaPlayerState.e_JSMediaPlayerStateSuspend = 4 }
| Enumeration for media player state. More...
enum | Language { Language.e_LanguageUnknown = 0, Language.e_LanguageCHS = 1, Language.e_LanguageCHT = 2, Language.e_LanguageDAN = 3, Language.e_LanguageDEU = 4, Language.e_LanguageENU = 5, Language.e_LanguageESP = 6, Language.e_LanguageFRA = 7, Language.e_LanguageITA = 8, Language.e_LanguageKOR = 9, Language.e_LanguageJPN = 10, Language.e_LanguageNLD = 11, Language.e_LanguageNOR = 12, Language.e_LanguagePTB = 13, Language.e_LanguageSUO = 14, Language.e_LanguageSVE = 15 }
| Enumeration for language. More...
enum | LayoutMode { LayoutMode.e_LayoutModeSinglePage = 0, LayoutMode.e_LayoutModeContinuous = 1, LayoutMode.e_LayoutModeFacing = 2, LayoutMode.e_LayoutModeContinuousFacing = 3 }
| Enumeration for layout mode. More...
enum | MailType { MailType.e_MailTypeDoc = 0, MailType.e_MailTypeForm = 1, MailType.e_MailTypeMsg = 2 }
| Enumeration for data type to be mailed. More...
enum | ModifyItemType { ModifyItemType.e_ModifyItemTypeNone = 0, ModifyItemType.e_ModifyItemTypeField = 1, ModifyItemType.e_ModifyItemTypeAnnot = 2, ModifyItemType.e_ModifyItemTypePage = 3, ModifyItemType.e_ModifyItemTypeDoc = 4 }
| Enumeration for modify item type. More...
enum | SearchScope { SearchScope.e_SearchScopeActiveDoc = 0, SearchScope.e_SearchScopeFolder = 1, SearchScope.e_SearchScopeIndex = 2, SearchScope.e_SearchScopeActiveIndexes = 3 }
| Enumeration for search scope. More...

## Public Member Functions
virtual bool | AddMenuItem (MenuItemConfig menu_item_config, bool is_prepend)
| A callback function to adds a menu item to a menu. More...
virtual SearchIndexConfig | AddSearchIndex (string di_path, bool is_selected)
| A callback function to add a search index. More...
virtual bool | AddSubMenu (MenuItemConfig menu_item_config)
| A callback function to add a menu item with a submenu to the application. More...
virtual bool | AddToolButton (ButtonItem button_item)
| A callback function to add a tool button. More...
virtual int | Alert (string msg, string title, int type, int icon)
| A callback function used to pop up a dialog to show warnings or hints. More...
virtual bool | Beep (int type)
| A callback function to cause the system to play a sound. More...
virtual string | BrowseFile ()
| A callback function to show a file selection dialog, and the selected file path should be returned. More...
virtual string | BrowseFile (bool is_open_dialog, string file_format, string file_filter)
| A callback function to show a file selection dialog. More...
virtual void | CloseDoc (PDFDoc document, bool is_prompt_to_save)
| A callback function to close document. More...
virtual PDFDoc | CreateBlankDoc ()
| A callback function to create a blank PDF document object. More...
virtual void | EnablePageLoop (bool is_loop)
| A callback function to set the flag specifies whether the document will loop around to the beginning of the document in response to a page advance (whether generated by mouse click, keyboard, or timer) in full screen mode. More...
virtual bool | ExecuteNamedAction (PDFDoc document, string named_action)
| A callback function to execute a named action. More...
virtual string | GetAppInfo (ActionCallback.AppInfoType type)
| A callback function to get application information. More...
virtual string | GetAttachmentsFilePath (PDFDoc pdf_doc, string name)
| A callback function to get the file path of attachments file. More...
virtual PDFDoc | GetCurrentDoc ()
| A callback function to receive current PDF document object. More...
virtual int | GetCurrentPage (PDFDoc document)
| A callback function used to receive current page index. More...
virtual bool | GetDocChangeMark (PDFDoc document)
| A callback function to receive the change mark which indicates whether the content of document is changed or not. More...
virtual string | GetExtractedEmbeddedFilePath (PDFDoc pdf_doc, string name)
| A callback function to get the file path of extracted embedded file. More...
virtual string | GetFilePath (PDFDoc document)
| A callback function to get the file path of current PDF document. More...
virtual bool | GetFullScreen ()
| A callback function to get whether the full screen mode is set. More...
virtual IdentityProperties | GetIdentityProperties ()
| A callback function used to get identity properties of current user. More...
virtual ActionCallback.Language | GetLanguage ()
| A callback function to get the language of the running viewer application. More...
virtual ActionCallback.LayoutMode | GetLayoutMode ()
| A callback function to get the page layout of the current document. More...
virtual MenuListArray | GetMenuItemNameList ()
| A callback function to get the menu item name list. More...
virtual PointF | GetMousePosition ()
| A callback function to get current mouse position. More...
virtual PDFDoc | GetOpenedDoc (int index)
| A callback function to receive an opened PDF document object by index. More...
virtual int | GetOpenedDocCount ()
| A callback function to receive the count of opened documents. More...
virtual Rotation | GetPageRotation (PDFDoc document, int page_index)
| A callback function used to receive current displaying rotation of a page on PDF viewer. More...
virtual float | GetPageScale ()
| A callback function to get current page zoom value. More...
virtual RectF | GetPageWindowRect (PDFDoc document, int page_index)
| A callback function to get the rectangle for the page view window. The page view window is the area inside the inner document window in which the PDF content is displayed. More...
virtual Destination.ZoomMode | GetPageZoomMode ()
| A callback function to get the current page zoom mode. More...
virtual WStringArray | GetPrinterNameList ()
| A callback function to get the printer name list. More...
virtual WStringArray | GetSignatureAPStyleNameList ()
| A callback function to get the name list of signature appearance style. More...
virtual string | GetTemporaryDirectory ()
| A callback function to get temporary directory. More...
virtual string | GetTemporaryFileName (PDFDoc document, string file_suffix_name)
| A callback function to get the temporary file path. The temporary file name combine the document name with the file suffix name. More...
virtual string | GetUntitledBookmarkName ()
| A callback function to get the new name for an untitled bookmark. More...
virtual int | GetVisiblePage (PDFDoc document, int index)
| A callback function to get the visible page index. More...
virtual int | GetVisiblePageCount (PDFDoc document)
| A callback function to get the visible pages count. More...
virtual bool | InitModifyItem (PDFDoc document, ActionCallback.ModifyItemType item_type, int page_index, string dict_name)
| A callback function to init modify item. More...
virtual bool | InvalidateRect (PDFDoc document, int page_index, RectF pdf_rect)
| A callback function to invalidate the client area within the specified rectangle. More...
virtual bool | IsCurrentDocOpenedInBrowser ()
| A callback function to get the flag specifies whether current document is opened in browser. More...
virtual bool | IsLocalFile (PDFDoc document)
| A callback function to check whether the file is local file. More...
virtual bool | IsPageLoop ()
| A callback function to get the flag specifies whether the document will loop around to the beginning of the document in response to a page advance. More...
virtual bool | LaunchURL (string url)
| A callback function to launch to a specified URL. More...
virtual bool | MailData (global::System.IntPtr data, ActionCallback.MailType data_type, bool is_ui, string to, string subject, string cc, string bcc, string message)
| A callback function to mail data or message, with or without user interaction. More...
virtual ActionCallback.JsMailResult | MailDoc (PDFDoc document, string to_address, string cc_address, string bcc_address, string subject, string message, bool is_ui)
| A callback function to mails a document as an attachment. More...
virtual void | NotifyAfterDataChange (PDFDoc document, JavascriptModifyItemInfo modify_item_info)
| A callback function to notify that data has been modified. More...
virtual void | NotifyBeginDoJob (PDFDoc document, JavascriptModifyItemInfo.JavascriptEventType event_type)
| A callback function used to notify javascript execution to begin. More...
virtual void | NotifyEndDoJob (PDFDoc document, JavascriptModifyItemInfo.JavascriptEventType event_type)
| A callback function to notify that javascript execution has ended. More...
virtual void | OnFieldValueChanged (string field_name, ActionCallback.JSFieldValueChangeType type, WStringArray value_before_changed, WStringArray value_after_changed)
| A callback function to notify the value change of the field. More...
virtual PDFDoc | OpenDoc (string file_path, string password)
| A callback function to open a PDF file. More...
virtual MediaPlayerCallback | OpenMediaPlayer (PlayerArgs player_args)
| A callback function to open media player. More...
virtual string | PopupMenu (MenuListArray menus, ref bool is_selected_item)
| A callback function to pop up a menu window. More...
virtual MenuItemEx | PopupMenuEx (MenuItemExArray menus, ref bool is_selected_item)
| A callback function to pop up a menu window. More...
virtual void | PostMessageToHtml (WStringArray message)
| A callback function to send message asynchronously to the message handler for the host container of the PDF document. More...
virtual bool | Print (PDFDoc document, bool is_ui, Range page_range, bool is_silent, bool is_shrunk_to_fit, bool is_printed_as_image, bool is_reversed, bool is_to_print_annots)
| A callback function to print pages within a specified index range. More...
virtual bool | Print (PDFDoc document, PrintParams print_params)
| A callback function to print document with print parameters. More...
virtual void | Query (string keywords, ActionCallback.SearchScope search_scope, SearchOption search_option, string di_path)
| A callback function to query the text keywords. More...
virtual void | Release ()
| A callback function used to release current callback object itself. More...
virtual bool | RemoveSearchIndex (SearchIndexConfig search_index_config)
| (Reserved, unsupported yet) A callback function to remove a search index. More...
virtual bool | RemoveToolButtom (string button_name)
| A callback function to remove a tool button added by the function ActionCallback.AddToolButton . More...
virtual void | ResetModifyItem (PDFDoc document)
| A callback function to reset modify item. More...
virtual string | Response (string question, string title, string default_value, string label, bool is_password)
| A callback function to display a dialog box containing a question and an entry field for the user to reply to the question. More...
virtual void | Scroll (PointF point)
| A callback function to scroll the specified point on the current page into the middle of the current view. More...
virtual void | SelectPageNthWord (int page_index, int start_offset, int end_offset, bool is_show_selection)
| A callback function to change the current page number and selects the specified word on the page. More...
virtual void | SetCurrentPage (PDFDoc document, int page_index)
| A callback function used to set the current page by index. More...
virtual void | SetCurrentPage (PDFDoc document, Destination destination)
| A callback function used to set the current page by destination. More...
virtual void | SetDefaultPageTransitionMode (string trans_type, string trans_di)
| A callback function to set the default page trastion mode for full screen mode. More...
virtual bool | SetDocChangeMark (PDFDoc document, bool change_mark)
| A callback function to set the change mark which indicates whether the content of document is changed or not. More...
virtual void | SetFullScreen (bool is_full_screen)
| A callback function to set full screen mode. More...
virtual bool | SetIdentityProperties (IdentityProperties identity_properties)
| A callback function used to set identity properties of current user. More...
virtual void | SetLayoutMode (ActionCallback.LayoutMode layout_mode, bool is_cover_mode)
| A callback function to set the page layout of the current document. More...
virtual bool | SetPageRotation (PDFDoc document, int page_index, Rotation rotation)
| A callback function used to set the rotation value of a page on PDF viewer. More...
virtual void | SetPageScale (Destination.ZoomMode zoom_mode, Destination dest)
| A callback function to set current page zoom value. More...
virtual bool | ShowDialog (DialogDescriptionConfig dlg_config)
| A callback function to show the dialog. More...
virtual SOAPResponseInfo | SoapRequest (SOAPRequestProperties request_params)
| Initiates a remote procedure call (RPC) or sends an XML message to a SOAP HTTP endpoint. More...
virtual bool | SubmitForm (PDFDoc document, global::System.IntPtr form_data, int length, string url, FileFormatType file_format_type)
| A callback function to submit the form data to a specified URL. More...
virtual void | UpdateLogicalLabel ()
| A callback function to update logical label. More...
virtual uint | VerifySignature (PDFDoc document, Signature pdf_signature)
| A callback function to verify specified signature.. More...

## Detailed Description

This class represents a callback object for performing PDF actions. All the pure virtual functions in this class are used as callback functions and should be implemented by user, to perform PDF actions, such as javascript actions.

## Member Enumeration Documentation

## ◆ AppInfoType

enum foxit.pdf.actions.ActionCallback.AppInfoType
| strong

Enumeration for application's information type.

Values of this enumeration should be used alone.

Enumerator
e_AppInfoTypeFormsVersion | Application's forms version information.
e_AppInfoTypeViewerType | Application's viewer type information.
e_AppInfoTypeViewerVariation | Application's viewer variation information.
e_AppInfoTypeViewerVersion | Application's viewer version information.
e_AppInfoTypeAppVersion | Application's app version information.

## ◆ JSFieldValueChangeType

enum foxit.pdf.actions.ActionCallback.JSFieldValueChangeType
| strong

Enumeration for javascript field value change type.

Values of this enumeration should be used alone.

Enumerator
e_JSFieldValueChangedByFormat | javascript field value changed type: format.
e_JSFieldValueChangedByCalculation | javascript field value changed type : calculation.
e_JSFieldValueChangedBySetValue | javascript field value changed type: field set value.
e_JSFieldValueChangedBySetReadOnly | javascript field value changed type: field set read-only property.
e_JSFieldValueChangedByFillColor | javascript field value changed type: field fill color.

## ◆ JsMailResult

enum foxit.pdf.actions.ActionCallback.JsMailResult
| strong

Enumeration for result of the mail.

Values of this enumeration should be used alone.

Enumerator
e_JSMailResultFailed | Mailed result: mail failed.
e_JSMailResultSuccess | Mailed result: mail success.
e_JSMailResultUserAbort | Mailed result: user abort.

## ◆ JSMediaPlayerState

enum foxit.pdf.actions.ActionCallback.JSMediaPlayerState
| strong

Enumeration for media player state.

Values of this enumeration should be used alone.

Enumerator
e_JSMediaPlayerStateOpen | media player state: Open.
e_JSMediaPlayerStateClose | media player state: Close.
e_JSMediaPlayerStatePlaying | media player state: Playing.
e_JSMediaPlayerStateStop | media player state: Stop.
e_JSMediaPlayerStateSuspend | media player state: Suspend.

## ◆ Language

enum foxit.pdf.actions.ActionCallback.Language
| strong

Enumeration for language.

Values of this enumeration should be used alone.

Enumerator
e_LanguageUnknown | Unknown language.
e_LanguageCHS | Chinese Simplified.
e_LanguageCHT | Chinese Traditional.
e_LanguageDAN | Danish.
e_LanguageDEU | German.
e_LanguageENU | English.
e_LanguageESP | Spanish.
e_LanguageFRA | French.
e_LanguageITA | Italian.
e_LanguageKOR | Korean.
e_LanguageJPN | Japanese.
e_LanguageNLD | Dutch.
e_LanguageNOR | Norwegian.
e_LanguagePTB | Brazilian Portuguese.
e_LanguageSUO | Finnish.
e_LanguageSVE | Swedish.

## ◆ LayoutMode

enum foxit.pdf.actions.ActionCallback.LayoutMode
| strong

Enumeration for layout mode.

Values of this enumeration should be used alone.

Enumerator
e_LayoutModeSinglePage | Layout mode: single page.
e_LayoutModeContinuous | Layout mode: continuous page.
e_LayoutModeFacing | Layout mode: two pages.
e_LayoutModeContinuousFacing | Layout mode: continuous two pages.

## ◆ MailType

enum foxit.pdf.actions.ActionCallback.MailType
| strong

Enumeration for data type to be mailed.

Values of this enumeration should be used alone.

Enumerator
e_MailTypeDoc | Mailed data type: document.
e_MailTypeForm | Mailed data type: form.
e_MailTypeMsg | Mailed data type: string message.

## ◆ ModifyItemType

enum foxit.pdf.actions.ActionCallback.ModifyItemType
| strong

Enumeration for modify item type.

Values of this enumeration should be used alone.

Enumerator
e_ModifyItemTypeNone | Modify item type: none.
e_ModifyItemTypeField | Modify item type: Field.
e_ModifyItemTypeAnnot | Modify item type: Annot.
e_ModifyItemTypePage | Modify item type: Page.
e_ModifyItemTypeDoc | Modify item type: Doc.

## ◆ SearchScope

enum foxit.pdf.actions.ActionCallback.SearchScope
| strong

Enumeration for search scope.

Values of this enumeration should be used alone.

Enumerator
e_SearchScopeActiveDoc | Search scope: active document.
e_SearchScopeFolder | Search scope: folder.
e_SearchScopeIndex | Search scope: index.
e_SearchScopeActiveIndexes | Search scope: active indexes.

## Member Function Documentation

## ◆ AddMenuItem()

bool foxit.pdf.actions.ActionCallback.AddMenuItem | ( | MenuItemConfig | menu_item_config,
|  | bool | is_prepend
| ) |  |
| inline virtual

A callback function to adds a menu item to a menu.

This callback function will be triggered by the javascript method "app.addMenuItem".

Parameters

  [in] | menu_item_config | The config of the menu item.
  [in] | is_prepend | Determines the position of the new menu item relative to the position specified by MenuItemConfig::pos or MenuItemConfig::pos_str. The default value is false. If this parameter is true, the rules for insertion are as follows: If MenuItemConfig::pos_str is used, the new item is placed before the named item. If MenuItemConfig::pos is used, the new item is placed before the numbered item. If the named item cannot be found or position is not between zero and the number of items in the list, inclusive, the new item is inserted as the first item in the menu (rather than at the end of the menu). parameter is useful when the named item is the first item in a group.

Returns
  true means success, while false means failure.

## ◆ AddSearchIndex()

SearchIndexConfig foxit.pdf.actions.ActionCallback.AddSearchIndex | ( | string | di_path,
|  | bool | is_selected
| ) |  |
| inline virtual

A callback function to add a search index.

This callback function will be triggered by the javascript method "search.addIndex". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | di_path | A device-independent path to an index file on the user's hard drive.
  [in] | is_selected | Specifies whether the index should be selected for searching. Default value: true.

Returns
  A SearchIndexConfig .

## ◆ AddSubMenu()

bool foxit.pdf.actions.ActionCallback.AddSubMenu | ( | MenuItemConfig | menu_item_config | ) |
| inline virtual

A callback function to add a menu item with a submenu to the application.

This callback function will be triggered by the javascript method "app.addSubMenu".

Parameters

  [in] | menu_item_config | The config of the menu item.

Returns
  true means success, while false means failure.

## ◆ AddToolButton()

bool foxit.pdf.actions.ActionCallback.AddToolButton | ( | ButtonItem | button_item | ) |
| inline virtual

A callback function to add a tool button.

This callback function will be triggered by the javascript method "app.addToolButton".

Parameters

  [in] | button_item | The ButtonItem object of the tool button.

Returns
  true means success, while false means failure.

## ◆ Alert()

int foxit.pdf.actions.ActionCallback.Alert | ( | string | msg,
|  | string | title,
|  | int | type,
|  | int | icon
| ) |  |
| inline virtual

A callback function used to pop up a dialog to show warnings or hints.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | msg | The message string to be displayed in the dialog.
  [in] | title | The title of the dialog.
  [in] | type | Type of button group. It would be one of following values: 0: OK;(default value.) 1: OK, Cancel; 2: Yes, NO; 3: Yes, NO, Cancel.
  [in] | icon | Icon type. It would be one of following values: 0: Error;(default value.) 1: Warning; 2: Question; 3: Status.

Returns
  The return value should be one of following values:

  - 1: OK;

  - 2: Cancel;

  - 3: NO;

  - 4: Yes;

## ◆ Beep()

bool foxit.pdf.actions.ActionCallback.Beep | ( | int | type | ) |
| inline virtual

A callback function to cause the system to play a sound.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | type | Sound type. The value would be on of following values: 0: Error 1: Warning 2: Question 3: Status 4: Default (default value)

Returns
  true means success, while false means failure.

## ◆ BrowseFile() [1/2]

string foxit.pdf.actions.ActionCallback.BrowseFile | ( |  | ) |
| inline virtual

A callback function to show a file selection dialog, and the selected file path should be returned.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The file path. It can be an empty string.

## ◆ BrowseFile() [2/2]

string foxit.pdf.actions.ActionCallback.BrowseFile | ( | bool | is_open_dialog,
|  | string | file_format,
|  | string | file_filter
| ) |  |
| inline virtual

A callback function to show a file selection dialog.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | is_open_dialog | A boolean value to specify whether the dialog is for opening file or saving file. true means the dialog should be used to open file, while false means the dialog should be used to save file.
  [in] | file_format | The file format string.
  [in] | file_filter | The file filter string.

Returns
  The file path. It can be an empty string.

## ◆ CloseDoc()

void foxit.pdf.actions.ActionCallback.CloseDoc | ( | PDFDoc | document,
|  | bool | is_prompt_to_save
| ) |  |
| inline virtual

A callback function to close document.

This callback function will be triggered by the javascript method "Doc.closeDoc". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | is_prompt_to_save | true means show save prompt, while false means not.

Returns
  None.

## ◆ CreateBlankDoc()

PDFDoc foxit.pdf.actions.ActionCallback.CreateBlankDoc | ( |  | ) |
| inline virtual

A callback function to create a blank PDF document object.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The newly created blank PDF document object.

## ◆ EnablePageLoop()

void foxit.pdf.actions.ActionCallback.EnablePageLoop | ( | bool | is_loop | ) |
| inline virtual

A callback function to set the flag specifies whether the document will loop around to the beginning of the document in response to a page advance (whether generated by mouse click, keyboard, or timer) in full screen mode.

This callback function will be triggered by the javascript property "app.fs.loop". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | is_loop | true means to loop around to the beginning of the document, while false means not.

Returns
  None.

## ◆ ExecuteNamedAction()

bool foxit.pdf.actions.ActionCallback.ExecuteNamedAction | ( | PDFDoc | document,
|  | string | named_action
| ) |  |
| inline virtual

A callback function to execute a named action.

Please refer to description of "Named Actions" in Section 8.5.3 of <PDF Reference 1.7> for more details. This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | named_action | A string to specify a named action.

Returns
  true means success, while false means failure.

## ◆ GetAppInfo()

string foxit.pdf.actions.ActionCallback.GetAppInfo | ( | ActionCallback.AppInfoType | type | ) |
| inline virtual

A callback function to get application information.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.
For the digital information like foxit.pdf.actions.ActionCallback.AppInfoType.e_AppInfoTypeViewerVersion , foxit.pdf.actions.ActionCallback.AppInfoType.e_AppInfoTypeAppVersion and foxit.pdf.actions.ActionCallback.AppInfoType.e_AppInfoTypeFormsVersion , please use string to represent it.

Parameters

  [in] | type | Type of information. Please refer to values starting from foxit.pdf.actions.ActionCallback.AppInfoType.e_AppInfoTypeFormsVersion and this would be one of these values.

Returns
  The application information.

## ◆ GetAttachmentsFilePath()

string foxit.pdf.actions.ActionCallback.GetAttachmentsFilePath | ( | PDFDoc | pdf_doc,
|  | string | name
| ) |  |
| inline virtual

A callback function to get the file path of attachments file.

This callback function will be triggered by the javascript method "Doc.importDataObject". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | pdf_doc | A PDF document object. It will embed with a data object.
  [in] | name | The name to associate with the data object. It's the parameter "cName" of the method "Doc.importDataObject".

Returns
  The path of the file which will be embedded as a data object.

## ◆ GetCurrentDoc()

PDFDoc foxit.pdf.actions.ActionCallback.GetCurrentDoc | ( |  | ) |
| inline virtual

A callback function to receive current PDF document object.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  Current PDF document object.

## ◆ GetCurrentPage()

int foxit.pdf.actions.ActionCallback.GetCurrentPage | ( | PDFDoc | document | ) |
| inline virtual

A callback function used to receive current page index.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.

Returns
  Current page index. The value should be stared from 0 and less than page count of the specified document.

## ◆ GetDocChangeMark()

bool foxit.pdf.actions.ActionCallback.GetDocChangeMark | ( | PDFDoc | document | ) |
| inline virtual

A callback function to receive the change mark which indicates whether the content of document is changed or not.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.

Returns
  true means the PDF document is changed, while false means not.

## ◆ GetExtractedEmbeddedFilePath()

string foxit.pdf.actions.ActionCallback.GetExtractedEmbeddedFilePath | ( | PDFDoc | pdf_doc,
|  | string | name
| ) |  |
| inline virtual

A callback function to get the file path of extracted embedded file.

This callback function will be triggered by the javascript method "Doc.exportDataObject". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | pdf_doc | A PDF document object. It will be embedded as a data object to the file .
  [in] | name | The name of the data object to extract. It's the parameter "cName" of the method "Doc.exportDataObject".

Returns
  The path of the file which will embed with a data object.

## ◆ GetFilePath()

string foxit.pdf.actions.ActionCallback.GetFilePath | ( | PDFDoc | document | ) |
| inline virtual

A callback function to get the file path of current PDF document.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.

Returns
  The file path.

## ◆ GetFullScreen()

bool foxit.pdf.actions.ActionCallback.GetFullScreen | ( |  | ) |
| inline virtual

A callback function to get whether the full screen mode is set.

This callback function will be triggered by the javascript property "app.fullScreen" or "app.fs.isFullScreen".

Returns
  true means the full screen mode is set, while false means not.

## ◆ GetIdentityProperties()

IdentityProperties foxit.pdf.actions.ActionCallback.GetIdentityProperties | ( |  | ) |
| inline virtual

A callback function used to get identity properties of current user.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  An identity properties object that specifies the identity properties of current user.

## ◆ GetLanguage()

ActionCallback.Language foxit.pdf.actions.ActionCallback.GetLanguage | ( |  | ) |
| inline virtual

A callback function to get the language of the running viewer application.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The language type. Please refer to values starting from foxit.pdf.actions.ActionCallback.Language.e_LanguageUnknown and this should be one of these values.

## ◆ GetLayoutMode()

ActionCallback.LayoutMode foxit.pdf.actions.ActionCallback.GetLayoutMode | ( |  | ) |
| inline virtual

A callback function to get the page layout of the current document.

This callback function will be triggered by the javascript properties "Doc.layout". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The layout mode. Please refer to values starting from foxit.pdf.actions.ActionCallback.LayoutMode.e_LayoutModeSinglePage and this should be one of these values.

## ◆ GetMenuItemNameList()

MenuListArray foxit.pdf.actions.ActionCallback.GetMenuItemNameList | ( |  | ) |
| inline virtual

A callback function to get the menu item name list.

This callback function will be triggered by the javascript method "app.listMenuItems".

Returns
  An array of menu list objects.

## ◆ GetMousePosition()

PointF foxit.pdf.actions.ActionCallback.GetMousePosition | ( |  | ) |
| inline virtual

A callback function to get current mouse position.

This callback function will be triggered by the javascript properties "doc.mouseX" or "doc.mouseY". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  A position in device coordinate system.

## ◆ GetOpenedDoc()

PDFDoc foxit.pdf.actions.ActionCallback.GetOpenedDoc | ( | int | index | ) |
| inline virtual

A callback function to receive an opened PDF document object by index.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | index | The index of an opened PDF documents. Valid range: from 0 to count-1. count is returned by callback function ActionCallback.GetOpenedDocCount ;

Returns
  A opened PDF document object.

## ◆ GetOpenedDocCount()

int foxit.pdf.actions.ActionCallback.GetOpenedDocCount | ( |  | ) |
| inline virtual

A callback function to receive the count of opened documents.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The count of opened documents.

## ◆ GetPageRotation()

Rotation foxit.pdf.actions.ActionCallback.GetPageRotation | ( | PDFDoc | document,
|  | int | page_index
| ) |  |
| inline virtual

A callback function used to receive current displaying rotation of a page on PDF viewer.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | page_index | A page index, used to specify which page's rotation is to be retrieved. The index would start from 0 and less than page count of the specified document.

Returns
  The rotation of specified page. Please refer to values starting from foxit.common.Rotation.e_Rotation0 and this should be one of these values.

## ◆ GetPageScale()

float foxit.pdf.actions.ActionCallback.GetPageScale | ( |  | ) |
| inline virtual

A callback function to get current page zoom value.

This callback function will be triggered by the javascript properties "Doc.zoom". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  A zoom value. For example, a zoom value of 1.0 specifies 100%. It should be a positive number.

## ◆ GetPageWindowRect()

RectF foxit.pdf.actions.ActionCallback.GetPageWindowRect | ( | PDFDoc | document,
|  | int | page_index
| ) |  |
| inline virtual

A callback function to get the rectangle for the page view window. The page view window is the area inside the inner document window in which the PDF content is displayed.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | page_index | The page index.

This callback function will be triggered by the javascript property "Doc.pageWindowRect". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  A rectangle for the page view window.

## ◆ GetPageZoomMode()

Destination.ZoomMode foxit.pdf.actions.ActionCallback.GetPageZoomMode | ( |  | ) |
| inline virtual

A callback function to get the current page zoom mode.

This callback function will be triggered by the javascript properties "Doc.zoom" or "Doc.zoomType". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The zoom mode. Please refer to values starting from foxit.pdf.actions.Destination.ZoomMode.e_ZoomXYZ and this should be one of these values.

## ◆ GetPrinterNameList()

WStringArray foxit.pdf.actions.ActionCallback.GetPrinterNameList | ( |  | ) |
| inline virtual

A callback function to get the printer name list.

This callback function will be triggered by the javascript property "app.printerNames". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  An array of the printer name.

## ◆ GetSignatureAPStyleNameList()

WStringArray foxit.pdf.actions.ActionCallback.GetSignatureAPStyleNameList | ( |  | ) |
| inline virtual

A callback function to get the name list of signature appearance style.

This callback function will be triggered by the javascript method "SecurityHandler.appearances". This callback function is optional, so it can be implemented to do nothing.

Returns
  An array of signature appearance style name.

## ◆ GetTemporaryDirectory()

string foxit.pdf.actions.ActionCallback.GetTemporaryDirectory | ( |  | ) |
| inline virtual

A callback function to get temporary directory.

This callback function will be triggered by the javascript method "Doc.extractpages". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  The temporary directory.

## ◆ GetTemporaryFileName()

string foxit.pdf.actions.ActionCallback.GetTemporaryFileName | ( | PDFDoc | document,
|  | string | file_suffix_name
| ) |  |
| inline virtual

A callback function to get the temporary file path. The temporary file name combine the document name with the file suffix name.

This callback function will be triggered by the javascript method "Doc.mailForm". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | file_suffix_name | File suffix name.

Returns
  The temporary file path.

## ◆ GetUntitledBookmarkName()

string foxit.pdf.actions.ActionCallback.GetUntitledBookmarkName | ( |  | ) |
| inline virtual

A callback function to get the new name for an untitled bookmark.

This callback function will be triggered by the javascript mothod "bookmark.createChild" when the parameter "cName" of the method is an empty string. This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  A new name for an untitled bookmark.

## ◆ GetVisiblePage()

int foxit.pdf.actions.ActionCallback.GetVisiblePage | ( | PDFDoc | document,
|  | int | index
| ) |  |
| inline virtual

A callback function to get the visible page index.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | index | The visible page index. Valid range: from 0 to (count-1). count is returned by function .

Returns
  The page index of visible page.

## ◆ GetVisiblePageCount()

int foxit.pdf.actions.ActionCallback.GetVisiblePageCount | ( | PDFDoc | document | ) |
| inline virtual

A callback function to get the visible pages count.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.

Returns
  The count of visible pages.

## ◆ InitModifyItem()

bool foxit.pdf.actions.ActionCallback.InitModifyItem | ( | PDFDoc | document,
|  | ActionCallback.ModifyItemType | item_type,
|  | int | page_index,
|  | string | dict_name
| ) |  |
| inline virtual

A callback function to init modify item.

This callback function is optional, so it can be implemented to do nothing if no action is required.

Parameters

  [in] | document | A PDF document object. It should be valid.
  [in] | item_type | The modify item type. Please refer to values starting from foxit.pdf.actions.ActionCallback.ModifyItemType.e_ModifyItemTypeNone and this should be one of these values.
  [in] | page_index | A page index which is used to change current page.
  [in] | dict_name | The name of the dictionary.

Returns
  true means that the modified item was initialized successfully, and false means that initialization failed.

## ◆ InvalidateRect()

bool foxit.pdf.actions.ActionCallback.InvalidateRect | ( | PDFDoc | document,
|  | int | page_index,
|  | RectF | pdf_rect
| ) |  |
| inline virtual

A callback function to invalidate the client area within the specified rectangle.

All positions are measured in PDF "user space". Implementation should call function common.Renderer.StartRender for repainting a specified page area.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | page_index | A page index. It would start from 0 and less than page count of the specified document.
  [in] | pdf_rect | A rectangle that specifies the page area in PDF coordinate system. If this is an empty rectangle, that means to refresh the whole page.

Returns
  true means success, while false means failure.

## ◆ IsCurrentDocOpenedInBrowser()

bool foxit.pdf.actions.ActionCallback.IsCurrentDocOpenedInBrowser | ( |  | ) |
| inline virtual

A callback function to get the flag specifies whether current document is opened in browser.

This callback function will be triggered by the javascript property "doc.hostContainer". This callback function is optional, so it can be implemented to do nothing.

Returns
  true means current document is opened in browser, while false means not.

## ◆ IsLocalFile()

bool foxit.pdf.actions.ActionCallback.IsLocalFile | ( | PDFDoc | document | ) |
| inline virtual

A callback function to check whether the file is local file.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.

Returns
  true means the PDF file is loacl file.

## ◆ IsPageLoop()

bool foxit.pdf.actions.ActionCallback.IsPageLoop | ( |  | ) |
| inline virtual

A callback function to get the flag specifies whether the document will loop around to the beginning of the document in response to a page advance.

This callback function will be triggered by the javascript property "app.fs.loop". This callback function is optional, so it can be implemented to do nothing.

Returns
  true means to loop around to the beginning of the document, while false means not.

## ◆ LaunchURL()

bool foxit.pdf.actions.ActionCallback.LaunchURL | ( | string | url | ) |
| inline virtual

A callback function to launch to a specified URL.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | url | A URL.

Returns
  true means success, while false means failure.

## ◆ MailData()

bool foxit.pdf.actions.ActionCallback.MailData | ( | global::System.IntPtr | data,
|  | ActionCallback.MailType | data_type,
|  | bool | is_ui,
|  | string | to,
|  | string | subject,
|  | string | cc,
|  | string | bcc,
|  | string | message
| ) |  |
| inline virtual

A callback function to mail data or message, with or without user interaction.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | data | A data which is to be mailed. The value and type of the data depends on parameter data_type: This should be null when parameter data_type is foxit.pdf.actions.ActionCallback.MailType.e_MailTypeMsg . This should represents a WString object when parameter data_type is foxit.pdf.actions.ActionCallback.MailType.e_MailTypeForm . This should represents a foxit.pdf.PDFDoc object when parameter data_type is foxit.pdf.actions.ActionCallback.MailType.e_MailTypeDoc .
  [in] | data_type | Mail type. Please refer to values starting from foxit.pdf.actions.ActionCallback.MailType.e_MailTypeDoc and this would be one of these values.
  [in] | is_ui | true means that the remaining parameters are used to seed the compose-new-message window which is displayed to the user. false means that the parameter to is required and all other parameters are optional.
  [in] | to | A string that specifies a semicolon-delimited list of recipients for the message.
  [in] | subject | A string that specifies the subject of the message. The limit of this string's length is 64 KB.
  [in] | cc | A string that specifies a semicolon-delimited list of CC recipients for the message.
  [in] | bcc | A string that specifies a semicolon-delimited list of BCC recipients for the message.
  [in] | message | A string that specifies the content of the message. The limit of this string's length is 64 KB.

Returns
  true means success, while false means failure.

## ◆ MailDoc()

ActionCallback.JsMailResult foxit.pdf.actions.ActionCallback.MailDoc | ( | PDFDoc | document,
|  | string | to_address,
|  | string | cc_address,
|  | string | bcc_address,
|  | string | subject,
|  | string | message,
|  | bool | is_ui
| ) |  |
| inline virtual

A callback function to mails a document as an attachment.

This callback function will be triggered by the javascript method "Doc.mailDoc". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | to_address | To address.
  [in] | cc_address | Cc address.
  [in] | bcc_address | Bcc address.
  [in] | subject | Mail subject.
  [in] | message | Mail message.
  [in] | is_ui | true means to show mail dialog, while false means not.

Returns
  The mail result. Please refer to values starting from foxit.pdf.actions.ActionCallback.JsMailResult.e_JSMailResultFailed and this should be one of these values.

## ◆ NotifyAfterDataChange()

void foxit.pdf.actions.ActionCallback.NotifyAfterDataChange | ( | PDFDoc | document,
|  | JavascriptModifyItemInfo | modify_item_info
| ) |  |
| inline virtual

A callback function to notify that data has been modified.

This callback function is optional, so it can be implemented to do nothing if no action is required.

Parameters

  [in] | document | A PDF document object. It should be valid.
  [in] | modify_item_info | A JavascriptModifyItemInfo object containing details about the modification.

Returns
  None.

## ◆ NotifyBeginDoJob()

void foxit.pdf.actions.ActionCallback.NotifyBeginDoJob | ( | PDFDoc | document,
|  | JavascriptModifyItemInfo.JavascriptEventType | event_type
| ) |  |
| inline virtual

A callback function used to notify javascript execution to begin.

This callback function is optional, so it can be implemented to do nothing if no action is required.

Parameters

  [in] | document | A PDF document object. It should be valid.
  [in] | event_type | The javascript event type. Please refer to values starting from foxit.pdf.actions.JavascriptModifyItemInfo.JavascriptEventType.e_JavascriptEventTypeUnknown and this should be one of these values.

Returns
  None.

## ◆ NotifyEndDoJob()

void foxit.pdf.actions.ActionCallback.NotifyEndDoJob | ( | PDFDoc | document,
|  | JavascriptModifyItemInfo.JavascriptEventType | event_type
| ) |  |
| inline virtual

A callback function to notify that javascript execution has ended.

This callback function is optional, so it can be implemented to do nothing if no action is required.

Parameters

  [in] | document | A PDF document object. It should be valid.
  [in] | event_type | The javascript event type. Please refer to values starting from foxit.pdf.actions.JavascriptModifyItemInfo.JavascriptEventType.e_JavascriptEventTypeUnknown and this should be one of these values.

Returns
  None.

## ◆ OnFieldValueChanged()

void foxit.pdf.actions.ActionCallback.OnFieldValueChanged | ( | string | field_name,
|  | ActionCallback.JSFieldValueChangeType | type,
|  | WStringArray | value_before_changed,
|  | WStringArray | value_after_changed
| ) |  |
| inline virtual

A callback function to notify the value change of the field.

This callback function will be triggered when the field's value is changed via JavaScript.

Parameters

  [in] | field_name | A string that specifies the field name.
  [in] | type | Field value change type. Please refer to values starting from foxit.pdf.actions.ActionCallback.JSFieldValueChangeType.e_JSFieldValueChangedByFormat and this would be one of these values.
  [in] | value_before_changed | A string array that specifies the field's value before the change.

For a list box, the parameter represent one or more than one of the field's items which be selected simultaneously.

Parameters

  [in] | value_after_changed | A string array that specifies the field's value after the change. For a list box, the parameter represent one or more than one of the field's items which be selected simultaneously.

Returns
  None.

## ◆ OpenDoc()

PDFDoc foxit.pdf.actions.ActionCallback.OpenDoc | ( | string | file_path,
|  | string | password
| ) |  |
| inline virtual

A callback function to open a PDF file.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | file_path | A full path of an existing PDF file.
  [in] | password | Password for input PDF file. This may be an empty string.

Returns
  An opened PDF document object.

## ◆ OpenMediaPlayer()

MediaPlayerCallback foxit.pdf.actions.ActionCallback.OpenMediaPlayer | ( | PlayerArgs | player_args | ) |
| inline virtual

A callback function to open media player.

This callback function will be triggered by the javascript method "app.media.openPlayer" or "app.media.createPlayer".

Parameters

  [in] | player_args | The PlayerArgs object.

Returns
  A MediaPlayerCallback object.

## ◆ PopupMenu()

string foxit.pdf.actions.ActionCallback.PopupMenu | ( | MenuListArray | menus,
|  | ref bool | is_selected_item
| ) |  |
| inline virtual

A callback function to pop up a menu window.

The position of menu window is the same as cursor's. This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | menus | An array of menu list objects.
  [out] | is_selected_item | Output parameter that receives the value of whether a menu item is selected or not. true means that the menu item is selected, while false means that the menu item is not selected.

Returns
  The name of the menu item that was selected.

## ◆ PopupMenuEx()

MenuItemEx foxit.pdf.actions.ActionCallback.PopupMenuEx | ( | MenuItemExArray | menus,
|  | ref bool | is_selected_item
| ) |  |
| inline virtual

A callback function to pop up a menu window.

The position of menu window is the same as cursor's. This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | menus | An array of MenuItemEx objects.
  [out] | is_selected_item | Output parameter that receives the value of whether a menu item is selected or not. true means that the menu item is selected, while false means that the menu item is not selected.

Returns
  The MenuItemEx object of the menu item that was selected.

## ◆ PostMessageToHtml()

void foxit.pdf.actions.ActionCallback.PostMessageToHtml | ( | WStringArray | message | ) |
| inline virtual

A callback function to send message asynchronously to the message handler for the host container of the PDF document.

For this message to be delivered, the host container (for example, an <OBJECT> element in an HTML page) must have registered for notification by setting its messageHandler property.
This callback function will be triggered by the javascript method "doc.hostContainer.postMessage". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | message | An array of string that specifies the message to be posted.

Returns
  None.

## ◆ Print() [1/2]

bool foxit.pdf.actions.ActionCallback.Print | ( | PDFDoc | document,
|  | bool | is_ui,
|  | Range | page_range,
|  | bool | is_silent,
|  | bool | is_shrunk_to_fit,
|  | bool | is_printed_as_image,
|  | bool | is_reversed,
|  | bool | is_to_print_annots
| ) |  |
| inline virtual

A callback function to print pages within a specified index range.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | is_ui | true means that a UI should be presented to the user to obtain printing information and confirm the action.
  [in] | page_range | A range object to specify the page range for printing. All the indexes represented in this range would start from 0 and less than page count of the specified document.
  [in] | is_silent | true means that the cancel dialog box should be suppressed while the document is printing.
  [in] | is_shrunk_to_fit | true means that the page should be shrunk (if necessary) to fit within the area of the printed page.
  [in] | is_printed_as_image | true means that pages should be printed as image.
  [in] | is_reversed | true means that the printing order should be from parameter end to parameter start.
  [in] | is_to_print_annots | true means that annotations should be printed with page.

Returns
  true means success, while false means failure.

## ◆ Print() [2/2]

bool foxit.pdf.actions.ActionCallback.Print | ( | PDFDoc | document,
|  | PrintParams | print_params
| ) |  |
| inline virtual

A callback function to print document with print parameters.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | print_params | A PrintParams object.

Returns
  true means success, while false means failure.

## ◆ Query()

void foxit.pdf.actions.ActionCallback.Query | ( | string | keywords,
|  | ActionCallback.SearchScope | search_scope,
|  | SearchOption | search_option,
|  | string | di_path
| ) |  |
| inline virtual

A callback function to query the text keywords.

This callback function will be triggered by the javascript method "search.query". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | keywords | The text content for which to search.
  [in] | search_scope | Specifies where the text should be searched. Please refer to values starting from foxit.pdf.actions.ActionCallback.SearchScope.e_SearchScopeActiveDoc and this should be one of these values.
  [in] | search_option | A SearchOption object that represents search option.
  [in] | di_path | A device-independent path to a folder or search index on the user's computer. This parameter is optional. When search_scope is foxit.pdf.actions.ActionCallback.SearchScope.e_SearchScopeFolder or foxit.pdf.actions.ActionCallback.SearchScope.e_SearchScopeIndex , this parameter is required.

Returns
  None.

## ◆ Release()

void foxit.pdf.actions.ActionCallback.Release | ( |  | ) |
| inline virtual

A callback function used to release current callback object itself.

Returns
  None.

## ◆ RemoveSearchIndex()

bool foxit.pdf.actions.ActionCallback.RemoveSearchIndex | ( | SearchIndexConfig | search_index_config | ) |
| inline virtual

(Reserved, unsupported yet) A callback function to remove a search index.

This callback function will be triggered by the javascript method "search.removeIndex". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | search_index_config | A SearchIndexConfig that represents the search index config.

Returns
  true means success, while false means failure.

## ◆ RemoveToolButtom()

bool foxit.pdf.actions.ActionCallback.RemoveToolButtom | ( | string | button_name | ) |
| inline virtual

A callback function to remove a tool button added by the function ActionCallback.AddToolButton .

This callback function will be triggered by the javascript method "app.removeToolButton".

Parameters

  [in] | button_name | The name of the tool button.

Returns
  true means success, while false means failure.

## ◆ ResetModifyItem()

void foxit.pdf.actions.ActionCallback.ResetModifyItem | ( | PDFDoc | document | ) |
| inline virtual

A callback function to reset modify item.

This callback function is optional, so it can be implemented to do nothing if no action is required.

Parameters

  [in] | document | A PDF document object. It should be valid.

Returns
  None.

## ◆ Response()

string foxit.pdf.actions.ActionCallback.Response | ( | string | question,
|  | string | title,
|  | string | default_value,
|  | string | label,
|  | bool | is_password
| ) |  |
| inline virtual

A callback function to display a dialog box containing a question and an entry field for the user to reply to the question.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | question | A string that specifies the question to be posed to the user.
  [in] | title | A string that specifies the title of the dialog box.
  [in] | default_value | A string that specifies a default value as the answer to the question. If the answer is not specified, no default value is presented.
  [in] | label | A string that specifies a short string to appear in front of the edit text field.
  [in] | is_password | A boolean value that indicates whether user's response should be masked to show: true means that the user's response should show as asterisks (*) or bullets (?) to mask the response, which might be sensitive information.

Returns
  User's response. It can be an empty string.

## ◆ Scroll()

void foxit.pdf.actions.ActionCallback.Scroll | ( | PointF | point | ) |
| inline virtual

A callback function to scroll the specified point on the current page into the middle of the current view.

This callback function will be triggered by the javascript method "Doc.scroll". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | point | The specified point[PDF coordinate system].

Returns
  None.

## ◆ SelectPageNthWord()

void foxit.pdf.actions.ActionCallback.SelectPageNthWord | ( | int | page_index,
|  | int | start_offset,
|  | int | end_offset,
|  | bool | is_show_selection
| ) |  |
| inline virtual

A callback function to change the current page number and selects the specified word on the page.

This callback function will be triggered by the javascript method "Doc.selectPageNthWord". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | page_index | The page index.
  [in] | start_offset | The start word offset.
  [in] | end_offset | The end word offset.
  [in] | is_show_selection | true means to show selection, while false means not.

Returns
  None.

## ◆ SetCurrentPage() [1/2]

void foxit.pdf.actions.ActionCallback.SetCurrentPage | ( | PDFDoc | document,
|  | int | page_index
| ) |  |
| inline virtual

A callback function used to set the current page by index.

This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | page_index | A page index which is used to change current page. The index would start from 0 and less than page count of the specified document.

Returns
  None.

## ◆ SetCurrentPage() [2/2]

void foxit.pdf.actions.ActionCallback.SetCurrentPage | ( | PDFDoc | document,
|  | Destination | destination
| ) |  |
| inline virtual

A callback function used to set the current page by destination.

This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | destination | A

## ◆ SetDefaultPageTransitionMode()

void foxit.pdf.actions.ActionCallback.SetDefaultPageTransitionMode | ( | string | trans_type,
|  | string | trans_di
| ) |  |
| inline virtual

A callback function to set the default page trastion mode for full screen mode.

This callback function will be triggered by the javascript property "app.fs.defaultTransition". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | trans_type | A string that specifies the type of the transition effect. Please refer to the follow values: "Split", "Box", "Fly", "Blinds", "Push", "Wipe", "Glitter", "Cover", "Uncover", "Dissolve", "Replace", "Fade".
  [in] | trans_di | A string that specifies the direction of the transition effect. For "Split", this value can be "HorizontalInward", "HorizontalOutward", "VerticalInward" or "VerticalOutward". For "Box", this value can be "Outward" or "Inward". For "Fly" and "Push", this value can be "Left", "Right", "Up" or "Down". For "Blinds", this value can be "Horizontal" or "Vertical". For "Wipe", "Glitter", "Uncover" and "Cover", this value can be "Left","LeftUp", "LeftDown", "Right", "RightUp", "RightDown","Up" or "Down". For "Dissolve", "Replace" and "Fade", this value will be NULL.

Returns
  None.

## ◆ SetDocChangeMark()

bool foxit.pdf.actions.ActionCallback.SetDocChangeMark | ( | PDFDoc | document,
|  | bool | change_mark
| ) |  |
| inline virtual

A callback function to set the change mark which indicates whether the content of document is changed or not.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | change_mark | A boolean value that indicates whether the content of document is changed or not.

Returns
  true means success, while false means failure.

## ◆ SetFullScreen()

void foxit.pdf.actions.ActionCallback.SetFullScreen | ( | bool | is_full_screen | ) |
| inline virtual

A callback function to set full screen mode.

This callback function will be triggered when the javascript property "app.fullScreen" or "app.fs.isFullScreen" is to be set.

Parameters

  [in] | is_full_screen | true means to set full screen mode, while false means not.

Returns
  None.

## ◆ SetIdentityProperties()

bool foxit.pdf.actions.ActionCallback.SetIdentityProperties | ( | IdentityProperties | identity_properties | ) |
| inline virtual

A callback function used to set identity properties of current user.

This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | identity_properties | An identity properties object used to be set.

Returns
  true means success, while false means failure.

## ◆ SetLayoutMode()

void foxit.pdf.actions.ActionCallback.SetLayoutMode | ( | ActionCallback.LayoutMode | layout_mode,
|  | bool | is_cover_mode
| ) |  |
| inline virtual

A callback function to set the page layout of the current document.

This callback function will be triggered by the javascript properties "Doc.layout". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | layout_mode | The layout mode. Please refer to values starting from foxit.pdf.actions.ActionCallback.LayoutMode.e_LayoutModeSinglePage and this should be one of these values.
  [in] | is_cover_mode | true means that the cover will always displayed separately, while false means not.

Returns
  None.

## ◆ SetPageRotation()

bool foxit.pdf.actions.ActionCallback.SetPageRotation | ( | PDFDoc | document,
|  | int | page_index,
|  | Rotation | rotation
| ) |  |
| inline virtual

A callback function used to set the rotation value of a page on PDF viewer.

This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | page_index | A page index, used to specify which page's rotation is to be changed. The index would start from 0 and less than page count of the specified document.
  [in] | rotation | New rotation value. Please refer to values starting from foxit.common.Rotation.e_Rotation0 and this should be one of these values except foxit.common.Rotation.e_RotationUnknown .

Returns
  true means success, while false means failure.

## ◆ SetPageScale()

void foxit.pdf.actions.ActionCallback.SetPageScale | ( | Destination.ZoomMode | zoom_mode,
|  | Destination | dest
| ) |  |
| inline virtual

A callback function to set current page zoom value.

This callback function will be triggered by the javascript properties "Doc.zoom" or "Doc.zoomType". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | zoom_mode | The zoom mode. Please refer to values starting from foxit.pdf.actions.Destination.ZoomMode.e_ZoomXYZ and this should be one of these values.
  [in] | dest | A foxit.pdf.actions.Destination object that represents destination data.

Returns
  None.

## ◆ ShowDialog()

bool foxit.pdf.actions.ActionCallback.ShowDialog | ( | DialogDescriptionConfig | dlg_config | ) |
| inline virtual

A callback function to show the dialog.

This callback function will be triggered by the javascript method "app.execDialog".

Parameters

  [in] | dlg_config | The DialogDescriptionConfig object.

Returns
  true means success, while false means failure.

## ◆ SoapRequest()

SOAPResponseInfo foxit.pdf.actions.ActionCallback.SoapRequest | ( | SOAPRequestProperties | request_params | ) |
| inline virtual

Initiates a remote procedure call (RPC) or sends an XML message to a SOAP HTTP endpoint.

The method either waits for the endpoint to reply (synchronous processing) or calls a method on the notification object (asynchronous processing).
This callback function will be triggered by the javascript method "SOAP.request". This callback function is optional, so it can be implemented to do nothing.

Parameters

  [in] | request_params | A SOAPRequestProperties object that contains the property parameters for the SOAP request.

Returns
  A SOAPResponseInfo object.

## ◆ SubmitForm()

bool foxit.pdf.actions.ActionCallback.SubmitForm | ( | PDFDoc | document,
|  | global::System.IntPtr | form_data,
|  | int | length,
|  | string | url,
|  | FileFormatType | file_format_type
| ) |  |
| inline virtual

A callback function to submit the form data to a specified URL.

This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | form_data | A form data buffer which is to be submitted.
  [in] | length | The size (in bytes) of the buffer parameterform_data.
  [in] | url | A URL, to which the form data will be submitted.
  [in] | file_format_type | File format type for submission form. Please refer to values starting from foxit.common.FileFormatType.e_FileFormatTypeFDF and this would be one of these values.

Returns
  true means success, while false means failure.

## ◆ UpdateLogicalLabel()

void foxit.pdf.actions.ActionCallback.UpdateLogicalLabel | ( |  | ) |
| inline virtual

A callback function to update logical label.

This callback function will be triggered by the javascript method "Doc.setPageLabels". This callback function is optional, so it can be implemented to do nothing and just return a useless value.

Returns
  None.

## ◆ VerifySignature()

uint foxit.pdf.actions.ActionCallback.VerifySignature | ( | PDFDoc | document,
|  | Signature | pdf_signature
| ) |  |
| inline virtual

A callback function to verify specified signature..

This callback function will be triggered when a signature is to be verified by an action. If user does not want to verify the signature, just implement this function to do nothing and just return foxit.pdf.Signature.States.e_StateUnknown . User is recommended to use class foxit.pdf.LTVVerifier to verify if a signed signature is valid or not.

Parameters

  [in] | document | A PDF document object. It would be valid.
  [in] | pdf_signature | A PDF signature which is signed. This signature belongs to input parameter document.

Returns
  The signature verified state. Please refer to values starting from foxit.pdf.Signature.States.e_StateUnknown and this would be one or combination of them.